/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
//import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NuclearCardiologyProtocols;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_RenalVessels;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_RenalVessels;


/**
 * This class represents RenalVessels - CID12115
 */
public class RenalVessels_CID12115 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;

	/**
	 * Instantiates a new RenalVessels_CID12115 Template 
	 */
	public RenalVessels_CID12115()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumRenalVessels Object of EnumCM_RenalVessels represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_RenalVessels enumRenalVessels)
	{
		switch(enumRenalVessels)
		{
		case RENAL_ARTERY:
			this.strCodeValue = EnumCV_RenalVessels.RENAL_ARTERY_T_46600
					.getValue();
			break;
		case HILAR_ARTERY:
			this.strCodeValue = EnumCV_RenalVessels.HILAR_ARTERY_G_035C
					.getValue();
			break;
		case SEGMENTAL_ARTERY:
			this.strCodeValue = EnumCV_RenalVessels.SEGMENTAL_ARTERY_T_46659
					.getValue();
			break;
		case LOBAR_ARTERY:
			this.strCodeValue = EnumCV_RenalVessels.LOBAR_ARTERY_T_4667C
					.getValue();
			break;
		case ARCUATE_ARTERY_OF_THE_KIDNEY:
			this.strCodeValue = EnumCV_RenalVessels.ARCUATE_ARTERY_OF_THE_KIDNEY_T_4668A
					.getValue();
			break;
		case INTERLOBAR_ARTERY_OF_KIDNEY:
			this.strCodeValue = EnumCV_RenalVessels.INTERLOBAR_ARTERY_OF_KIDNEY_T_4667D
					.getValue();
			break;
		case ACCESSORY_RENAL_ARTERY:
			this.strCodeValue = EnumCV_RenalVessels.ACCESSORY_RENAL_ARTERY_T_46640
					.getValue();
			break;
		case PERFORATING_ARTERY_OF_KIDNEY:
			this.strCodeValue = EnumCV_RenalVessels.PERFORATING_ARTERY_OF_KIDNEY_T_46668
					.getValue();
			break;
		case RENAL_VEIN:
			this.strCodeValue = EnumCV_RenalVessels.RENAL_VEIN_T_48740
					.getValue();
			break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumRenalVessels Object of EnumCM_RenalVessels represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_RenalVessels enumRenalVessels)
	{
		switch(enumRenalVessels)
		{
		case RENAL_ARTERY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.RENAL_ARTERY
					.getSNOMEDCTID();
			break;
		case HILAR_ARTERY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.HILAR_ARTERY
					.getSNOMEDCTID();
			break;
		case SEGMENTAL_ARTERY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.SEGMENTAL_ARTERY
					.getSNOMEDCTID();
			break;
		case LOBAR_ARTERY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.LOBAR_ARTERY
					.getSNOMEDCTID();
			break;
		case ARCUATE_ARTERY_OF_THE_KIDNEY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.ARCUATE_ARTERY_OF_THE_KIDNEY
					.getSNOMEDCTID();
			break;
		case INTERLOBAR_ARTERY_OF_KIDNEY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.INTERLOBAR_ARTERY_OF_KIDNEY
					.getSNOMEDCTID();
			break;
		case ACCESSORY_RENAL_ARTERY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.ACCESSORY_RENAL_ARTERY
					.getSNOMEDCTID();
			break;
		case PERFORATING_ARTERY_OF_KIDNEY:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.PERFORATING_ARTERY_OF_KIDNEY
					.getSNOMEDCTID();
			break;
		case RENAL_VEIN:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.RENAL_VEIN.getSNOMEDCTID();
			break;
		}
	}
	
	/**
	 * Sets the value for RenalVessels
	 * @param enumRenalVessels Object of EnumCM_RenalVessels.
	 */
	public void setRenalVessels(EnumCM_RenalVessels enumRenalVessels)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumRenalVessels.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumRenalVessels);
		
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumRenalVessels);
	}
}
